#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

// variables from firstnotes.c
extern int x, y, n, s, u, f, us;
extern char shortcodewert[4];
extern int combos[3][26][26][7][2][4];

// this function counts how many notes have been found (value, series)
int countseriesvaluenotes(int value, int series)
 {
  int a,b,e;
  int countseries=0;
  for(a=0;a<26;a++)
   {
    for(b=0;b<26;b++)
     {
      for(e=0;e<4;e++)
       {
        if(combos[1][a][b][value][series][e]==1)
         {
          if(combos[0][a][b][value][series][e]==1)
           {
            countseries++;
           }
         }
       }
     }
   }
  return countseries;
 }

// this function counts how many notes exists (value, series)
int countseriesvaluenotesavailable(int value, int series)
 {
  int a,b,e;
  int countseries=0;
  for(a=0;a<26;a++)
   {
    for(b=0;b<26;b++)
     {
      for(e=0;e<4;e++)
       {
        if(combos[1][a][b][value][series][e]==1)
         {
          countseries++;
         }
       }
     }
   }
  return countseries;
 }

// this function counts how many notes exists (value, series, signature)
int countseriesvaluesignaturenotesavailable(int value, int series, int signature)
 {
  int a,b;
  int countseries=0;
  for(a=0;a<26;a++)
   {
    for(b=0;b<26;b++)
     {
      if(combos[1][a][b][value][series][signature]==1)
       {
        countseries++;
       }
     }
   }
  return countseries;
 }

// this function counts how many notes have been found (value, series, signature)
int countseriesvaluesignaturenotes(int value, int series, int signature)
 {
  int a,b;
  int countseries=0;
  for(a=0;a<26;a++)
   {
    for(b=0;b<26;b++)
     {
      if(combos[1][a][b][value][series][signature]==1)
       {
        if(combos[0][a][b][value][series][signature]==1)
         {
          countseries++;
         }
       }
     }
   }
  return countseries;
 }

// this function counts how many notes exists (series)
int countseriesnotesavailable(int series)
 {
  int a,b,c,e;
  int countseries=0;
  for(a=0;a<26;a++)
     {
      for(b=0;b<26;b++)
       {
        for(c=0;c<7;c++)
         {
          for(e=0;e<4;e++)
           {
            if(combos[1][a][b][c][series][e]==1)
             {
              countseries++;
             }
           }
         }
       }
     }
  return countseries;
 }

// this function counts how many notes have been found (series)
int countseriesnotes(int series)
 {
  int a,b,c,e;
  int countseries=0;
  for(a=0;a<26;a++)
     {
      for(b=0;b<26;b++)
       {
        for(c=0;c<7;c++)
         {
          for(e=0;e<4;e++)
           {
            if(combos[1][a][b][c][series][e]==1)
             {
              if(combos[0][a][b][c][series][e]==1)
               {
                countseries++;
               }
             }
           }
         }
       }
     }
  return countseries;
 }

// this function counts and congrats if needed
void countandwrite(int value, int series)
 {
  int a,b;
  a=countseriesvaluenotes(value, series);
  b=countseriesvaluenotesavailable(value, series);
  printf(" %2d/%2d", a, b);
  if(a==b) printf(" Congratulation!");
  printf("\n");
 }

void tablecolumn(int value, int series)
 {
  int a;
  if(value==0) a=5;
  if(value==1) a=10;
  if(value==2) a=20;
  if(value==3) a=50;
  if(value==4) a=100;
  if(value==5) a=200;
  if(value==6) a=500;
  printf("  %3d ", a);
  if(series==0) printf(" 2002 ");
   else printf("Europa");
  int unterschrift=0;
  int b=0, c=0;
  for(unterschrift=0; unterschrift<4; unterschrift++)
   {
    b = countseriesvaluesignaturenotes(value,series,unterschrift);
    c = countseriesvaluesignaturenotesavailable(value,series,unterschrift);
    if(c != 0) printf(" %2d/%2d", b, c);
    else printf("      ");
   }
  countandwrite(value, series);
 }

// this function updates the array if a note have been found the first time
void scf(void)
 {
  combos[0][x][y][n][s][u]=1;
  f=1;
  us=u;
 }

// special handling for 20 F/N
void notescheck20FN(char secondpos, char thirdpos, char fourthpos, char fifthpos)
 {
  char serialpart[5];
  serialpart[0]=secondpos;
  serialpart[1]=thirdpos;
  serialpart[2]=fourthpos;
  serialpart[3]=fifthpos;
  serialpart[4]='\0';
  if(x == 5 && y == 13  && n == 2 && s == 0 && u == 0 && (atoi(serialpart) < 193)) scf();
  if(x == 5 && y == 13  && n == 2 && s == 0 && u == 1 && (atoi(serialpart) > 192)) scf();
 }

// special handling for 100 F/N
void notescheck100FN(char secondpos, char thirdpos, char fourthpos)
 {
  char serialpart[4];
  serialpart[0]=secondpos;
  serialpart[1]=thirdpos;
  serialpart[2]=fourthpos; 
  serialpart[3]='\0';
  if(x == 5 && y == 13  && n == 4 && s == 0 && u == 0 && (atoi(serialpart) < 37)) scf();
  if(x == 5 && y == 13  && n == 4 && s == 0 && u == 1 && (atoi(serialpart) > 36)) scf();
 }

// special handling for 10 K/T
void notescheck10KT(char secondpos)
 {
  if((x == 10 && y == 19 && n == 1 && s == 0 && secondpos == '2' && u == 1)) scf();
  if((x == 10 && y == 19 && n == 1 && s == 0 && secondpos == '5' && u == 2)) scf();
 }

// special handling for 10 P/X
void notescheck10PX(char secondpos, char thirdpos, char fourthpos)
 {
  char serialpart[4];
  serialpart[0]=secondpos;
  serialpart[1]=thirdpos;
  serialpart[2]=fourthpos;
  serialpart[3]='\0';
  if(x == 15 && y == 23  && n == 1 && s == 0 && u == 0 && (atoi(serialpart) < 224)) scf();
  if(x == 15 && y == 23  && n == 1 && s == 0 && u == 1 && (atoi(serialpart) > 239)) scf();
 }

// special handling for 20 Europa R/R
void notescheck20EuropaRR(char secondpos)
 {
  if((x==17 ) && (y==17) && (n==2) && (s==1) && (u==2) && (atoi(shortcodewert) == 13) && secondpos == 'B') scf();
  if((x==17 ) && (y==17) && (n==2) && (s==1) && (u==3) && (atoi(shortcodewert) == 13) && secondpos == 'P') scf();
 }

// special handling for 50 Europa S/S
void notescheck50EuropaSS(char fourthpos, char fifthpos, char sixthpos, char seventhpos, char eighthpos, char ninthpos)
 {
  // here we need a litte bit more complex. lmviterbo tried to figure out the logic
  int done=0;
  char serialpart[7]; 
  serialpart[0]=fourthpos;
  serialpart[1]=fifthpos;
  serialpart[2]=sixthpos;
  serialpart[3]=seventhpos;
  serialpart[4]=eighthpos;
  serialpart[5]=ninthpos;
  serialpart[6]='\0';

  // first we start with ranges for MD where we must check 6 digits of the serial number
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==2) && ((atoi(serialpart) > 675999) && (atoi(serialpart) < 676100))) { done=1; scf(); }
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==2) && ((atoi(serialpart) > 789299) && (atoi(serialpart) < 789700))) { done=1; scf(); }
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==2) && ((atoi(serialpart) > 841999) && (atoi(serialpart) < 842100))) { done=1; scf(); }

  // check now 6 digits of the serial number for CL
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==3) && ((atoi(serialpart) > 667466) && (atoi(serialpart) < 668046))) { done=1; scf(); }
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==3) && ((atoi(serialpart) > 827195) && (atoi(serialpart) < 827722))) { done=1; scf(); }

  // now we do the same, but only with 4 digits
  char serialpart2[5];
  serialpart2[0]=fourthpos;
  serialpart2[1]=fifthpos;
  serialpart2[2]=sixthpos;
  serialpart2[3]=seventhpos;
  serialpart2[4]='\0';

  // first we start with ranges for MD where we must check 4 digits of the serial number
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==2) && ((atoi(serialpart2) > 6512) && (atoi(serialpart2) < 6740))) { done=1; scf(); }
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==2) && ((atoi(serialpart2) > 6999) && (atoi(serialpart2) < 7857))) { done=1; scf(); }
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==2) && ((atoi(serialpart2) > 8001) && (atoi(serialpart2) < 8283))) { done=1; scf(); }

  // check now 4 digits of the serial number for CL
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==3) && ((atoi(serialpart2) > 6745) && (atoi(serialpart2) < 6996))) { done=1; scf(); }
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==3) && ((atoi(serialpart2) > 7857) && (atoi(serialpart2) < 7999))) { done=1; scf(); }
  if((done==0) && (x==18 ) && (y==18) && (n==3) && (s==1) && (u==3) && ((atoi(serialpart2) > 8283) && (atoi(serialpart2) < 9040))) { done=1; scf(); }
 }

// special handling for 10 Europa V/V
void notescheck10EuropaVV(char thirdpos, char fourthpos)
 {
  char serialpart[3];
  serialpart[0]=thirdpos;
  serialpart[1]=fourthpos;
  serialpart[2]='\0';
  if((x==21 ) && (y==21) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) == 11) && (atoi(serialpart) < 42)) scf();
  if((x==21 ) && (y==21) && (n==1) && (s==1) && (u==3) && (atoi(shortcodewert) == 11) && (atoi(serialpart) > 41)) scf();
 }

// special handling for 50 Europa V/V
void notescheck50EuropaVV(char thirdpos, char fourthpos, char fifthpos)
 {
  char serialpart[4];
  serialpart[0]=thirdpos;
  serialpart[1]=fourthpos;
  serialpart[2]=fifthpos;
  serialpart[3]='\0';
  if((x==21 ) && (y==21) && (n==3) && (s==1) && (u==2) && (atoi(shortcodewert) == 18) && (atoi(serialpart) < 964)) scf();
  if((x==21 ) && (y==21) && (n==3) && (s==1) && (u==3) && (atoi(shortcodewert) == 18) && (atoi(serialpart) > 963)) scf();
 }

// special handling for 50 Europa Y/Y
void notescheck50EuropaYY(char thirdpos, char fourthpos, char fifthpos, char sixthpos, char seventhpos)
 {
  char serialpart[6];
  serialpart[0]=thirdpos;
  serialpart[1]=fourthpos;
  serialpart[2]=fifthpos;
  serialpart[3]=sixthpos;
  serialpart[4]=seventhpos;
  serialpart[5]='\0';
  if((x==24 ) && (y==24) && (n==3) && (s==1) && (u==2) && (atoi(shortcodewert) == 3) && (atoi(serialpart) < 158)) scf();
  if((x==24 ) && (y==24) && (n==3) && (s==1) && (u==3) && (atoi(shortcodewert) == 3) && (atoi(serialpart) > 157)) scf();
 }

// function noteschecksignatures
void noteschecksignatures()
 {
  // 5 D/L WD
  if((x==3) && (y==11) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 10 D/L WD
  if((x==3) && (y==11) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 20 D/L WD
  if((x==3) && (y==11) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 50 D/L WD
  if((x==3) && (y==11) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 100 D/L WD
  if((x==3) && (y==11) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) < 3)) scf();
  // 200 D/L WD
  if((x==3) && (y==11) && (n==5) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 500 D/L WD
  if((x==3) && (y==11) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 5 E/E JCT
  if((x==4) && (y==4) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) == 10)) scf();
  // 5 E/E Europa CL
  if((x==4) && (y==4) && (n==0) && (s==1) && (u==3) && (atoi(shortcodewert) < 2)) scf();
  // 10 E/E Europa MD
  if((x==4) && (y==4) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) < 9)) scf();
  // 20 E/E Europa MD
  if((x==4) && (y==4) && (n==2) && (s==1) && (u==2) && (atoi(shortcodewert) < 9)) scf();
  // 20 E/E Europa CL
  if((x==4) && (y==4) && (n==2) && (s==1) && (u==3) && ((atoi(shortcodewert) > 8) && (atoi(shortcodewert) < 15))) scf();
  // 50 E/E Europa MD
  if((x==4) && (y==4) && (n==3) && (s==1) && (u==2) && (atoi(shortcodewert) < 16)) scf();
  // 50 E/E Europa CL
  if((x==4) && (y==4) && (n==3) && (s==1) && (u==3) && (((atoi(shortcodewert) > 15) && (atoi(shortcodewert) < 22)))) scf();
  // 100 E/E Europa MD
  if((x==4) && (y==4) && (n==4) && (s==1) && (u==2) && ((atoi(shortcodewert) < 7) || ((atoi(shortcodewert) > 7) && (atoi(shortcodewert) < 13)))) scf();
  // 100 E/E Europa CL
  if((x==4) && (y==4) && (n==4) && (s==1) && (u==3) && ((atoi(shortcodewert) > 12) && (atoi(shortcodewert) < 21))) scf();
  // 200 E/E Europa CL
  if((x==4) && (y==4) && (n==5) && (s==1) && (u==3) && ((atoi(shortcodewert) < 11))) scf();

  // 5 E/F JCT
  if((x==4) && (y==5) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) == 9)) scf();
  
  // 5 E/G JCT
  if((x==4) && (y==6) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) > 8) && (atoi(shortcodewert) < 11)) scf();

  // 5 E/H JCT
  if((x==4) && (y==7) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) == 10)) scf();
  // 20 E/H JCT
  if((x==4) && (y==7) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) > 2) && (atoi(shortcodewert) < 5)) scf();
    
  // 5 E/L JCT
  if((x==4) && (y==11) && (n==0) && (s==0) && (u==1) && ((atoi(shortcodewert) == 1) || ((atoi(shortcodewert) > 9) && (atoi(shortcodewert) < 12)))) scf();
  // 20 E/L JCT
  if((x==4) && (y==11) && (n==2) && (s==0) && (u==1) && ((atoi(shortcodewert) == 3) || (atoi(shortcodewert) == 5) || (atoi(shortcodewert) == 6))) scf();
  
  // 5 E/P JCT
  if((x==4) && (y==15) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) > 9) && (atoi(shortcodewert) < 11)) scf();

  // 20 E/U WD
  if((x==4) && (y==20) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 3)) scf();
  // 100 E/U WD
  if((x==4) && (y==20) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 10 E/X JCT
  if((x==4) && (y==23) && (n==1) && (s==0) && (u==1) && (atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 6)) scf();
  // 10 E/X MD
  if((x==4) && (y==23) && (n==1) && (s==0) && (u==2) && (atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 10)) scf();
  // 20 E/X MD
  if((x==4) && (y==23) && (n==2) && (s==0) && (u==2) && (atoi(shortcodewert) > 7) && (atoi(shortcodewert) < 11)) scf();
  // 50 E/X MD
  if((x==4) && (y==23) && (n==3) && (s==0) && (u==2) && (atoi(shortcodewert) < 6)) scf();
  // 100 E/X MD
  if((x==4) && (y==23) && (n==4) && (s==0) && (u==2) && (atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 6)) scf();
  // 200 E/X JCT
  if((x==4) && (y==23) && (n==5) && (s==0) && (u==1) && ((atoi(shortcodewert) == 1) || (atoi(shortcodewert) == 5))) scf();
  // 200 E/X MD
  if((x==4) && (y==23) && (n==5) && (s==0) && (u==2) && ((atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 5))) scf();

  // 10 F/F Europa MD
  if((x==5) && (y==5) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) < 7)) scf();
  // 20 F/F Europa CL
  if((x==5) && (y==5) && (n==2) && (s==1) && (u==3) && (atoi(shortcodewert) < 4)) scf();

  // 5 F/N WD
  if((x==5) && (y==13) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) < 5)) scf();
  // 5 F/N JCT
  if((x==5) && (y==13) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) == 5)) scf();
  // 10 F/N WD
  if((x==5) && (y==13) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) < 6)) scf();
  // 10 F/N JCT
  if((x==5) && (y==13) && (n==1) && (s==0) && (u==1) && (((atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 13)) || ((atoi(shortcodewert) > 13) && (atoi(shortcodewert) < 17)) || (atoi(shortcodewert) == 18) || (atoi(shortcodewert) == 20))) scf();
  // 20 F/N WD
  if((x==5) && (y==13) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 20 F/N JCT
  if((x==5) && (y==13) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) == 3)) scf();
  /* we have a special case: 20 F002/N could be WD or JCT, seperation is done via serial number
     WD:0000-0192, JCT:0193-9999
     this is done by function notescheck20FN */
  // 50 F/N WD
  if((x==5) && (y==13) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 100 F/N WD
  if((x==5) && (y==13) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 100 F/N JCT
  if((x==5) && (y==13) && (n==4) && (s==0) && (u==1) && ((atoi(shortcodewert) > 2) && (atoi(shortcodewert) < 6))) scf();
  /* we have a special case: 100 F002/N could be WD or JCT, seperation is done via serial number
     WD:000-036, JCT:037-999
     this is done by function notescheck100FN */
  // 100 F/N MD
  if((x==5) && (y==13) && (n==4) && (s==0) && (u==2) && ((atoi(shortcodewert) == 6) || (atoi(shortcodewert) == 7) || (atoi(shortcodewert) == 10) || (atoi(shortcodewert) == 11) || (atoi(shortcodewert) == 12))) scf();
  // 500 F/N WD
  if((x==5) && (y==13) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 500 F/N JCT
  if((x==5) && (y==13) && (n==6) && (s==0) && (u==1) && ((atoi(shortcodewert) == 2) || (atoi(shortcodewert) == 3) || (atoi(shortcodewert) == 5))) scf();
  // 500 F/N MD
  if((x==5) && (y==13) && (n==6) && (s==0) && (u==2) && (atoi(shortcodewert) > 6) && (atoi(shortcodewert) < 9)) scf();

  // 5 F/P WD
  if((x==5) && (y==15) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) == 3)) scf();
  // 500 F/P WD
  if((x==5) && (y==15) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 50 F/S JCT
  if((x==5) && (y==18) && (n==3) && (s==0) && (u==1) && (atoi(shortcodewert) > 2) && (atoi(shortcodewert) < 9)) scf();

  // 500 F/T WD
  if((x==5) && (y==19) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 10 F/Y WD
  if((x==5) && (y==24) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 20 G/E JCT
  if((x==6) && (y==4) && (n==2) && (s==0) && (u==1) && ((atoi(shortcodewert) == 10) || ((atoi(shortcodewert) > 11) && (atoi(shortcodewert) < 16)))) scf();

  // 20 G/F JCT
  if((x==6) && (y==5) && (n==2) && (s==0) && (u==1) && (((atoi(shortcodewert) > 6) && (atoi(shortcodewert) < 11)) || ((atoi(shortcodewert) > 11) && (atoi(shortcodewert) < 15)))) scf();

  // 20 G/G JCT
  if((x==6) && (y==6) && (n==2) && (s==0) && (u==1) && (((atoi(shortcodewert) > 6) && (atoi(shortcodewert) < 11)) || ((atoi(shortcodewert) > 11) && (atoi(shortcodewert) < 15)))) scf();

  // 20 G/H JCT
  if((x==6) && (y==7) && (n==2) && (s==0) && (u==1) && (((atoi(shortcodewert) > 6) && (atoi(shortcodewert) < 11)) || ((atoi(shortcodewert) > 11) && (atoi(shortcodewert) < 16)))) scf();

  // 20 G/L JCT
  if((x==6) && (y==11) && (n==2) && (s==0) && (u==1) && (((atoi(shortcodewert) > 4) && (atoi(shortcodewert) < 7)) || ((atoi(shortcodewert) > 9) && (atoi(shortcodewert) < 13)) || ((atoi(shortcodewert) > 13) && (atoi(shortcodewert) < 16)))) scf();

  // 200 G/N WD
  if((x==6) && (y==13) && (n==5) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 5 G/P WD
  if((x==6) && (y==15) && (n==0) && (s==0) && (u==0) && ((atoi(shortcodewert) == 1) || (atoi(shortcodewert) == 3) || (atoi(shortcodewert) == 4) || (atoi(shortcodewert) == 6) || (atoi(shortcodewert) == 7))) scf();

  /* 10 G/P WD */
  if((x==6) && (y==15) && (n==1) && (s==0) && (u==0) && ((atoi(shortcodewert) == 1) || ((atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 10)))) scf();
  /* 10 G/P JCT */
  if((x==6) && (y==15) && (n==1) && (s==0) && (u==1) && (((atoi(shortcodewert) > 9) && (atoi(shortcodewert) < 12)) || ((atoi(shortcodewert) > 12) && (atoi(shortcodewert) < 15)))) scf();
  /* 20 G/P WD */
  if((x==6) && (y==15) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 3)) scf();
  /* 20 G/P JCT */
  if((x==6) && (y==15) && (n==2) && (s==0) && (u==1) && ((atoi(shortcodewert) == 3) || ((atoi(shortcodewert) > 4) && (atoi(shortcodewert) < 13)) || (atoi(shortcodewert) == 14) || (atoi(shortcodewert) == 15))) scf();
  /* 50 G/P WD */
  if((x==6) && (y==15) && (n==3) && (s==0) && (u==0) && ((atoi(shortcodewert) < 3) || ((atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 12)) || (atoi(shortcodewert) == 16) || (atoi(shortcodewert) == 17) || ((atoi(shortcodewert) > 18) && (atoi(shortcodewert) < 22)))) scf();
  /* 50 G/P JCT */
  if((x==6) && (y==15) && (n==3) && (s==0) && (u==1) && (atoi(shortcodewert) > 22) && (atoi(shortcodewert) < 27)) scf();
  /* 100 G/P WD */
  if((x==6) && (y==15) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) < 4)) scf();
  /* 100 G/P JCT */
  if((x==6) && (y==15) && (n==4) && (s==0) && (u==1) && (atoi(shortcodewert) > 7) && (atoi(shortcodewert) < 10)) scf();
  /* 200 G/P WD */
  if((x==6) && (y==15) && (n==5) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  /* 10 G/V WD */
  if((x==6) && (y==21) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 6)) scf();

  /* 10 G/X JCT */
  if((x==6) && (y==23) && (n==1) && (s==0) && (u==1) && ((atoi(shortcodewert) > 14) && (atoi(shortcodewert) < 18))) scf();
  /* 50 G/X JCT */
  if((x==6) && (y==23) && (n==3) && (s==0) && (u==1) && ((atoi(shortcodewert) > 26) && (atoi(shortcodewert) < 41))) scf();
  /* 50 G/X MD */
  if((x==6) && (y==23) && (n==3) && (s==0) && (u==2) && ((atoi(shortcodewert) > 40) && (atoi(shortcodewert) < 45))) scf();

  /* 50 G/Y WD */
  if((x==6) && (y==24) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) > 12) && (atoi(shortcodewert) < 15)) scf();
  /* 100 G/Y WD */
  if((x==6) && (y==24) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) == 6)) scf();

  /* 20 H/L JCT */
  if((x==7) && (y==11) && (n==2) && (s==0) && (u==1) && ((atoi(shortcodewert) == 6))) scf();
  /* 50 H/L WD */
  if((x==7) && (y==11) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) > 4) && (atoi(shortcodewert) < 8)) scf();
  /* 100 H/L JCT */
  if((x==7) && (y==11) && (n==4) && (s==0) && (u==1) && (atoi(shortcodewert) < 3)) scf();

  // 20 H/M WD
  if((x==7) && (y==12) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 6)) scf();
  // 50 H/M WD
  if((x==7) && (y==12) && (n==3) && (s==0) && (u==0) && ((atoi(shortcodewert) < 5) || (atoi(shortcodewert) == 7) || (atoi(shortcodewert) == 8))) scf();

  // 50 H/P WD
  if((x==7) && (y==15) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) == 16)) scf();

  // 20 H/T WD
  if((x==7) && (y==19) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 5)) scf();

  // 5 J/S WD
  if((x==9) && (y==18) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) < 6)) scf();
  // 10 J/S WD
  if((x==9) && (y==18) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) < 6)) scf();
  // 10 J/S JCT
  if((x==9) && (y==18) && (n==1) && (s==0) && (u==1) && (atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 10)) scf();
  // 20 J/S WD
  if((x==9) && (y==18) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 11)) scf();
  // 20 J/S JCT
  if((x==9) && (y==18) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) > 11) && (atoi(shortcodewert) < 29)) scf();
  // 20 J/S MD
  if((x==9) && (y==18) && (n==2) && (s==0) && (u==2) && (atoi(shortcodewert) > 28) && (atoi(shortcodewert) < 37)) scf();
  // 50 J/S WD
  if((x==9) && (y==18) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) < 15)) scf();
  // 50 J/S JCT
  if((x==9) && (y==18) && (n==3) && (s==0) && (u==1) && (((atoi(shortcodewert) > 14) && (atoi(shortcodewert) < 25)) || ((atoi(shortcodewert) > 25) && (atoi(shortcodewert) < 56)) || ((atoi(shortcodewert) > 56) && (atoi(shortcodewert) < 71)) || ((atoi(shortcodewert) > 71) && (atoi(shortcodewert) < 79)) || ((atoi(shortcodewert) > 79) && (atoi(shortcodewert) < 82)))) scf();
  // 50 J/S MD
  if((x==9) && (y==18) && (n==3) && (s==0) && (u==2) && ((atoi(shortcodewert) == 79) || ((atoi(shortcodewert) > 82) && (atoi(shortcodewert) < 94)) || ((atoi(shortcodewert) > 94) && (atoi(shortcodewert) < 99)) || (atoi(shortcodewert) == 100) || (atoi(shortcodewert) == 102))) scf();
  // 100 J/S WD
  if((x==9) && (y==18) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) < 11)) scf();
  // 100 J/S JCT
  if((x==9) && (y==18) && (n==4) && (s==0) && (u==1) && (((atoi(shortcodewert) > 10) && (atoi(shortcodewert) < 26)) || ((atoi(shortcodewert) > 27) && (atoi(shortcodewert) < 35)))) scf();
  // 200 J/S WD
  if((x==9) && (y==18) && (n==5) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 500 J/S WD
  if((x==9) && (y==18) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  /* 5 K/T WD */
  if((x==10) && (y==19) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 5 K/T JCT */
  if((x==10) && (y==19) && (n==0) && (s==0) && (u==1) && ((atoi(shortcodewert) == 2) || (atoi(shortcodewert) == 3))) scf();
  /* 10 K/T WD */
  if((x==10) && (y==19) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) < 5)) scf();
  /* 10 K/T JCT */
  if((x==10) && (y==19) && (n==1) && (s==0) && (u==1) && ((atoi(shortcodewert) == 5) || (atoi(shortcodewert) == 6))) scf();
  /* we have a special case: 10 K007/T could be JCT or MD, seperation is done via serial number
     JCT:2738-2899, MD:5500-5610
     this is done by function notescheck10KT */
  /* 20 K/T WD */
  if((x==10) && (y==19) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) == 2)) scf();
  /* 20 K/T JCT */
  if((x==10) && (y==19) && (n==2) && (s==0) && (u==1) && ((atoi(shortcodewert) == 1) || (atoi(shortcodewert) == 3) || (atoi(shortcodewert) == 4))) scf();
  /* 50 K/T WD */
  if((x==10) && (y==19) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 100 K/T WD */
  if((x==10) && (y==19) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  /* 5 L/U WD */
  if((x==11) && (y==20) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) < 17)) scf();
  /* 5 L/U JCT */
  if((x==11) && (y==20) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) > 16) && (atoi(shortcodewert) < 33)) scf();
  /* 10 L/U WD */
  if((x==11) && (y==20) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 16)) scf();
  /* 10 L/U JCT */
  if((x==11) && (y==20) && (n==1) && (s==0) && (u==1) && (atoi(shortcodewert) > 15) && (atoi(shortcodewert) < 54)) scf();
  /* 20 L/U WD */
  if((x==11) && (y==20) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 30)) scf();
  /* 20 L/U JCT */
  if((x==11) && (y==20) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) > 29) && (atoi(shortcodewert) < 85)) scf();
  /* 20 L/U MD */
  if((x==11) && (y==20) && (n==2) && (s==0) && (u==2) && (atoi(shortcodewert) > 84) && (atoi(shortcodewert) < 89)) scf();
  /* 50 L/U WD */
  if((x==11) && (y==20) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 11)) scf();

  // 5 M/M Europa MD
  if((x==12) && (y==12) && (n==0) && (s==1) && (u==2) && (atoi(shortcodewert) < 8)) scf();
  // 5 M/M Europa CL
  if((x==12) && (y==12) && (n==0) && (s==1) && (u==3) && ((atoi(shortcodewert) > 7) && (atoi(shortcodewert) < 11))) scf();
  // 10 M/M Europa CL
  if((x==12) && (y==12) && (n==1) && (s==1) && (u==3) && (atoi(shortcodewert) < 2)) scf();
  // 20 M/M Europa MD
  if((x==12) && (y==12) && (n==2) && (s==1) && (u==2) && (atoi(shortcodewert) < 6)) scf();
  // 20 M/M Europa CL
  if((x==12) && (y==12) && (n==2) && (s==1) && (u==3) && ((atoi(shortcodewert) > 6) && (atoi(shortcodewert) < 8))) scf();
  // 50 M/M Europa MD
  if((x==12) && (y==12) && (n==3) && (s==1) && (u==2) && (atoi(shortcodewert) < 9)) scf();

  /* 5 M/V WD */
  if((x==12) && (y==21) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) < 4)) scf();
  /* 5 M/V JCT */
  if((x==12) && (y==21) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 17)) scf();
  /* 10 M/V WD */
  if((x==12) && (y==21) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) < 4)) scf();
  /* 20 M/V WD */
  if((x==12) && (y==21) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 13)) scf();
  /* 20 M/V JCT */
  if((x==12) && (y==21) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) > 12) && (atoi(shortcodewert) < 26)) scf();
  /* 50 M/V WD */
  if((x==12) && (y==21) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) < 16)) scf();
  /* 50 M/V JCT */
  if((x==12) && (y==21) && (n==3) && (s==0) && (u==1) && (atoi(shortcodewert) > 15) && (atoi(shortcodewert) < 50)) scf();
  /* 50 M/V MD */
  if((x==12) && (y==21) && (n==3) && (s==0) && (u==2) && (atoi(shortcodewert) > 49) && (atoi(shortcodewert) < 59)) scf();
  /* 100 M/V WD */
  if((x==12) && (y==21) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) < 3)) scf();
  /* 100 M/V MD */
  if((x==12) && (y==21) && (n==4) && (s==0) && (u==2) && ((atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 8))) scf();

  // 5 N/N Europa MD
  if((x==13) && (y==13) && (n==0) && (s==1) && (u==2) && (((atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 7)) || ((atoi(shortcodewert) > 7) && (atoi(shortcodewert) < 12)) || ((atoi(shortcodewert) > 13) && (atoi(shortcodewert) < 20)))) scf();
  // 5 N/N Europa CL
  if((x==13) && (y==13) && (n==0) && (s==1) && (u==3) && ((atoi(shortcodewert) > 19) && (atoi(shortcodewert) < 25))) scf();
  // 10 N/N Europa MD
  if((x==13) && (y==13) && (n==1) && (s==1) && (u==2) && ((atoi(shortcodewert) == 2) || (atoi(shortcodewert) == 5) || (atoi(shortcodewert) == 6) || (atoi(shortcodewert) == 8) || ((atoi(shortcodewert) > 9) && (atoi(shortcodewert) < 14)) || (atoi(shortcodewert) == 15))) scf();
  // 10 N/N Europa CL
  if((x==13) && (y==13) && (n==1) && (s==1) && (u==3) && ((atoi(shortcodewert) > 17) && (atoi(shortcodewert) < 20))) scf();
  // 20 N/N Europa MD
  if((x==13) && (y==13) && (n==2) && (s==1) && (u==2) && ((atoi(shortcodewert) == 1) || (atoi(shortcodewert) == 4) || (atoi(shortcodewert) == 5) || (atoi(shortcodewert) == 7) || (atoi(shortcodewert) == 8))) scf();
  // 20 N/N Europa CL
  if((x==13) && (y==13) && (n==2) && (s==1) && (u==3) && ((atoi(shortcodewert) > 8) && (atoi(shortcodewert) < 13))) scf();
  // 50 N/N Europa MD
  if((x==13) && (y==13) && (n==3) && (s==1) && (u==2) && ((atoi(shortcodewert) == 1))) scf();
  // 100 N/N Europa MD
  if((x==13) && (y==13) && (n==4) && (s==1) && (u==2) && ((atoi(shortcodewert) == 1) || (atoi(shortcodewert) == 4))) scf();
  // 200 N/N Europa MD
  if((x==13) && (y==13) && (n==5) && (s==1) && (u==2) && ((atoi(shortcodewert) < 4))) scf();
  // 200 N/N Europa CL
  if((x==13) && (y==13) && (n==5) && (s==1) && (u==3) && ((atoi(shortcodewert) > 3) || (atoi(shortcodewert) < 6))) scf();

  // 5 N/Y WD
  if((x==13) && (y==24) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 10 N/Y WD */
  if((x==13) && (y==24) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) < 7)) scf();
  /* 10 N/Y JCT */
  if((x==13) && (y==24) && (n==1) && (s==0) && (u==1) && (((atoi(shortcodewert) > 6) && (atoi(shortcodewert) < 35)) || (atoi(shortcodewert) == 36))) scf();
  /* 10 N/Y MD */
  if((x==13) && (y==24) && (n==1) && (s==0) && (u==2) && (atoi(shortcodewert) == 37)) scf();
  /* 20 N/Y WD */
  if((x==13) && (y==24) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 20 N/Y JCT */
  if((x==13) && (y==24) && (n==2) && (s==0) && (u==1) && ((atoi(shortcodewert) == 2) || (atoi(shortcodewert) == 3) || (atoi(shortcodewert) == 5) || (atoi(shortcodewert) == 6))) scf();
  /* 20 N/Y MD */
  if((x==13) && (y==24) && (n==2) && (s==0) && (u==2) && (atoi(shortcodewert) == 7)) scf();
  /* 50 N/Y WD */
  if((x==13) && (y==24) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  /* 20 P/L JCT */
  if((x==15) && (y==11) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) == 11)) scf();

  /* 100 P/M WD */
  if((x==15) && (y==12) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) == 5)) scf();

  /* 5 P/P WD */
  if((x==15) && (y==15) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) == 6)) scf();
  /* 10 P/P WD */
  if((x==15) && (y==15) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 10 P/P JCT */
  if((x==15) && (y==15) && (n==1) && (s==0) && (u==1) && (atoi(shortcodewert) == 15)) scf();
  /* 10 P/P Europa MD */
  if((x==15) && (y==15) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) < 7)) scf();
  /* 20 P/P WD */
  if((x==15) && (y==15) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) == 9)) scf();
  /* 50 P/P Europa MD */
  if((x==15) && (y==15) && (n==3) && (s==1) && (u==2) && (atoi(shortcodewert) < 10)) scf();

  /* 100 P/U WD */
  if((x==15) && (y==20) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 8)) scf();

  /* 50 P/V WD */
  if((x==15) && (y==21) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  /* 5 P/X WD */
  if((x==15) && (y==23) && (n==0) && (s==0) && (u==0) && ((atoi(shortcodewert) < 5) || ((atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 11)))) scf();
  /* 5 P/X JCT */
  if((x==15) && (y==23) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) > 10) && (atoi(shortcodewert) < 19)) scf();
  /* 10 P/X WD */
  if((x==15) && (y==23) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) < 5)) scf();
  /* 10 P/X JCT */
  if((x==15) && (y==23) && (n==1) && (s==0) && (u==1) && (atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 16)) scf();
  /* we have a special case: 10 P005/X could be WD or JCT, seperation is done via serial number
     P005 = WD:000-223, JCT:240-999
     this is done by function notescheck10PX */  
  /* 10 P/X MD */
  if((x==15) && (y==23) && (n==1) && (s==0) && (u==2) && (atoi(shortcodewert) > 15) && (atoi(shortcodewert) < 20)) scf();
  /* 20 P/X WD */
  if((x==15) && (y==23) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 11)) scf();
  /* 20 P/X JCT */
  if((x==15) && (y==23) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) > 10) && (atoi(shortcodewert) < 20)) scf();
  /* 50 P/X WD */
  if((x==15) && (y==23) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 12)) scf();
  /* 50 P/X JCT */
  if((x==15) && (y==23) && (n==3) && (s==0) && (u==1) && (atoi(shortcodewert) > 11) && (atoi(shortcodewert) < 32)) scf();
  /* 100 P/X WD */
  if((x==15) && (y==23) && (n==4) && (s==0) && (u==0) && ((atoi(shortcodewert) < 6) || (atoi(shortcodewert) == 7))) scf();
  /* 100 P/X JCT */
  if((x==15) && (y==23) && (n==4) && (s==0) && (u==1) && (atoi(shortcodewert) > 7) && (atoi(shortcodewert) < 11)) scf();

  /* 5 P/Y WD */
  if((x==15) && (y==24) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) == 5)) scf();
  /* 100 P/Y WD */
  if((x==15) && (y==24) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) == 5)) scf();

  // 20 R/D MD
  if((x==17) && (y==3) && (n==2) && (s==0) && (u==2) && (((atoi(shortcodewert) > 25) && (atoi(shortcodewert) < 32)))) scf();
  // 50 R/D MD
  if((x==17) && (y==3) && (n==3) && (s==0) && (u==2) && ((atoi(shortcodewert) == 47) || (atoi(shortcodewert) == 49) || (atoi(shortcodewert) == 51))) scf();

  /* 20 R/E MD */
  if((x==17) && (y==4) && (n==2) && (s==0) && (u==2) && ((atoi(shortcodewert) == 17) || (atoi(shortcodewert) == 20) || ((atoi(shortcodewert) > 25) && (atoi(shortcodewert) < 33)))) scf();
  /* 50 R/E MD */
  if((x==17) && (y==4) && (n==3) && (s==0) && (u==2) && ((atoi(shortcodewert) == 47) || (atoi(shortcodewert) == 48) || (atoi(shortcodewert) == 51) || (atoi(shortcodewert) == 52))) scf();

  /* 20 R/F MD */
  if((x==17) && (y==5) && (n==2) && (s==0) && (u==2) && ((atoi(shortcodewert) == 26) || (atoi(shortcodewert) == 27) || ((atoi(shortcodewert) > 28) && (atoi(shortcodewert) < 32)))) scf();
  /* 50 R/F MD */
  if((x==17) && (y==5) && (n==3) && (s==0) && (u==2) && (((atoi(shortcodewert) == 49) || (atoi(shortcodewert) == 51)))) scf();

  /* 20 R/G MD */
  if((x==17) && (y==6) && (n==2) && (s==0) && (u==2) && ((atoi(shortcodewert) == 26) || (atoi(shortcodewert) == 27) || ((atoi(shortcodewert) > 29) && (atoi(shortcodewert) < 32)))) scf();
  /* 50 R/G MD */
  if((x==17) && (y==6) && (n==3) && (s==0) && (u==2) && ((atoi(shortcodewert) == 49) || (atoi(shortcodewert) == 51))) scf();

  /* 20 R/H MD */
  if((x==17) && (y==7) && (n==2) && (s==0) && (u==2) && (((atoi(shortcodewert) > 25) && (atoi(shortcodewert) < 30)) || (atoi(shortcodewert) == 31))) scf();
  /* 50 R/H MD */
  if((x==17) && (y==7) && (n==3) && (s==0) && (u==2) && ((atoi(shortcodewert) == 47) || (atoi(shortcodewert) == 49) || (atoi(shortcodewert) == 51) || (atoi(shortcodewert) == 52))) scf();

  /* 20 R/L MD */
  if((x==17) && (y==11) && (n==2) && (s==0) && (u==2) && ((atoi(shortcodewert) == 15) || (atoi(shortcodewert) == 20) || ((atoi(shortcodewert) > 22) && (atoi(shortcodewert) < 28)) || ((atoi(shortcodewert) > 28) && (atoi(shortcodewert) < 32)))) scf();
  /* 50 R/L MD */
  if((x==17) && (y==11) && (n==3) && (s==0) && (u==2) && (((atoi(shortcodewert) > 46) && (atoi(shortcodewert) < 50)) || (atoi(shortcodewert) == 51))) scf();

  /* 5 R/P JCT */
  if((x==17) && (y==15) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) == 3)) scf();
  /* 20 R/P MD */
  if((x==17) && (y==15) && (n==2) && (s==0) && (u==2) && (((atoi(shortcodewert) > 14) && (atoi(shortcodewert) < 22)) || ((atoi(shortcodewert) > 22) && (atoi(shortcodewert) < 25)) || ((atoi(shortcodewert) > 28) && (atoi(shortcodewert) < 33)))) scf();
  /* 50 R/P MD */
  if((x==17) && (y==15) && (n==3) && (s==0) && (u==2) && (((atoi(shortcodewert) > 46) && (atoi(shortcodewert) < 50)) || (atoi(shortcodewert) == 51))) scf();

  // 10 R/R Europa CL
  if((x==17) && (y==17) && (n==1) && (s==1) && (u==3) && (atoi(shortcodewert) < 7)) scf();
  // 20 R013/R Europa can be MD or CL, there is an extra check for this
  // 20 R/R Europa MD
  if((x==17) && (y==17) && (n==2) && (s==1) && (u==2) && ((atoi(shortcodewert) < 9) || (atoi(shortcodewert) == 10) || (atoi(shortcodewert) == 12))) scf();
  // 20 R/R Europa CL
  if((x==17) && (y==17) && (n==2) && (s==1) && (u==3) && (((atoi(shortcodewert) > 13) && (atoi(shortcodewert) < 17)) || (atoi(shortcodewert) == 18) || ((atoi(shortcodewert) > 19) && (atoi(shortcodewert) < 23)) || ((atoi(shortcodewert) > 25) && (atoi(shortcodewert) < 30)))) scf();
  // 50 R/R Europa MD
  if((x==17) && (y==17) && (n==3) && (s==1) && (u==2) && ((atoi(shortcodewert) < 6) || (atoi(shortcodewert) == 8) || ((atoi(shortcodewert) > 9) && (atoi(shortcodewert) < 17)) || ((atoi(shortcodewert) > 20) && (atoi(shortcodewert) < 25)) || ((atoi(shortcodewert) > 25) && (atoi(shortcodewert) < 28)) || ((atoi(shortcodewert) > 28) && (atoi(shortcodewert) < 33)))) scf();
  // 50 R/R Europa CL
  if((x==17) && (y==17) && (n==3) && (s==1) && (u==3) && ((atoi(shortcodewert) > 33) && (atoi(shortcodewert) < 42))) scf();
  // 100 R/R Europa MD
  if((x==17) && (y==17) && (n==4) && (s==1) && (u==2) && ((atoi(shortcodewert) < 10) || (atoi(shortcodewert) == 11))) scf();

  /* 5 R/X JCT */
  if((x==17) && (y==23) && (n==0) && (s==0) && (u==1) && ((atoi(shortcodewert) < 3) || ((atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 7)))) scf();
  /* 10 R/X WD */
  if((x==17) && (y==23) && (n==1) && (s==0) && (u==0) && ((atoi(shortcodewert) < 14) || (atoi(shortcodewert) == 15))) scf();
  /* 10 R/X JCT */
  if((x==17) && (y==23) && (n==1) && (s==0) && (u==1) && ((atoi(shortcodewert) > 15) && (atoi(shortcodewert) < 27))) scf();
  /* 20 R/X JCT */
  if((x==17) && (y==23) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) < 9)) scf();
  /* 50 R/X WD */
  if((x==17) && (y==23) && (n==3) && (s==0) && (u==0) && ((atoi(shortcodewert) < 3) || ((atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 7)) || (atoi(shortcodewert) == 8) || ((atoi(shortcodewert) > 10) && (atoi(shortcodewert) < 21)))) scf();
  /* 50 R/X JCT */
  if((x==17) && (y==23) && (n==3) && (s==0) && (u==1) && (((atoi(shortcodewert) > 20) && (atoi(shortcodewert) < 40)) || (atoi(shortcodewert) == 41))) scf();
  /* 50 R/X MD */
  if((x==17) && (y==23) && (n==3) && (s==0) && (u==2) && ((atoi(shortcodewert) > 54) && (atoi(shortcodewert) < 60))) scf();
  // 100 R/X MD
  if((x==17) && (y==23) && (n==4) && (s==0) && (u==2) && ((atoi(shortcodewert) < 4) || ((atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 12)))) scf();
  /* 200 R/X WD */
  if((x==17) && (y==23) && (n==5) && (s==0) && (u==0) && ((atoi(shortcodewert) < 3) || ((atoi(shortcodewert) > 4) && (atoi(shortcodewert) < 7)))) scf();
  /* 200 R/X MD */
  if((x==17) && (y==23) && (n==5) && (s==0) && (u==2) && ((atoi(shortcodewert) == 8) || (atoi(shortcodewert) == 9))) scf();
  /* 500 R/X WD */
  if((x==17) && (y==23) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) < 5)) scf();
  /* 500 R/X JCT */
  if((x==17) && (y==23) && (n==6) && (s==0) && (u==1) && (((atoi(shortcodewert) > 6) && (atoi(shortcodewert) < 16)) || ((atoi(shortcodewert) > 16) && (atoi(shortcodewert) < 21)))) scf();

  /* 200 R/Y WD */
  if((x==17) && (y==24) && (n==5) && (s==0) && (u==0) && (atoi(shortcodewert) == 3)) scf();

  /* 500 R/Y WD */
  if((x==17) && (y==24) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 5)) scf();

  // 5 S/S Europa MD
  if((x==18) && (y==18) && (n==0) && (s==1) && (u==2) && ((atoi(shortcodewert) < 4) || (atoi(shortcodewert) == 6))) scf();
  // 10 S/S Europa MD
  if((x==18) && (y==18) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 6)) scf();
  // 20 S/S Europa MD
  if((x==18) && (y==18) && (n==2) && (s==1) && (u==2) && ((atoi(shortcodewert) == 1) || ((atoi(shortcodewert) > 2) && (atoi(shortcodewert) < 22)))) scf();
  // 20 S/S Europa CL
  if((x==18) && (y==18) && (n==2) && (s==1) && (u==3) && ((atoi(shortcodewert) > 21) && (atoi(shortcodewert) < 28))) scf();
  // 50 S036,S037 and S041/S Europa can be MD or CL, there is an extra check for this
// this check needs to be implemented in new functions above
  // 50 S/S Europa MD
  if((x==18) && (y==18) && (n==3) && (s==1) && (u==2) && (((atoi(shortcodewert) > 1) && (atoi(shortcodewert)) < 13) || ((atoi(shortcodewert) > 13) || (atoi(shortcodewert) < 20)) || (atoi(shortcodewert) == 21) || (atoi(shortcodewert) == 22) || ((atoi(shortcodewert) > 23) && (atoi(shortcodewert) < 36)))) scf();
  // 50 S/S Europa CL
  if((x==18) && (y==18) && (n==3) && (s==1) && (u==3) && ((atoi(shortcodewert) == 38) || (atoi(shortcodewert) == 39) || (atoi(shortcodewert) == 40) || (atoi(shortcodewert) == 42) || (atoi(shortcodewert) == 46) || ((atoi(shortcodewert) > 47) && (atoi(shortcodewert) < 51)) || ((atoi(shortcodewert) > 51) && (atoi(shortcodewert) < 54)))) scf();
  // 100 S/S Europa MD
  if((x==18) && (y==18) && (n==4) && (s==1) && (u==2) && (((atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 6)) || (atoi(shortcodewert) == 7) || (atoi(shortcodewert) == 8) || (atoi(shortcodewert) == 9))) scf();
  // 200 S/S Europa MD
  if((x==18) && (y==18) && (n==5) && (s==1) && (u==2) && ((atoi(shortcodewert) == 2) || ((atoi(shortcodewert) > 3) && (atoi(shortcodewert) < 7)) || (atoi(shortcodewert) == 8))) scf();

  // 5 T/T Europa MD
  if((x==19) && (y==19) && (n==0) && (s==1) && (u==2) && (atoi(shortcodewert) < 6)) scf();
  // 10 T/T Europa MD
  if((x==19) && (y==19) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) < 5)) scf();
  // 20 T/T Europa MD
  if((x==19) && (y==19) && (n==2) && (s==1) && (u==2) && (((atoi(shortcodewert) < 7)) || (atoi(shortcodewert) == 8) || (atoi(shortcodewert) == 10))) scf();

  // 200 T/U WD
  if((x==19) && (y==20) && (n==5) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 500 T/U WD
  if((x==19) && (y==20) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 200 T/V WD
  if((x==19) && (y==21) && (n==5) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 500 T/V WD
  if((x==19) && (y==21) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 5 T/Z WD
  if((x==19) && (y==25) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 10 T/Z WD */
  if((x==19) && (y==25) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 20 T/Z WD */
  if((x==19) && (y==25) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 3)) scf();
  /* 50 T/Z WD */
  if((x==19) && (y==25) && (n==3) && (s==0) && (u==0) && (atoi(shortcodewert) < 6)) scf();
  /* 50 T/Z JCT */
  if((x==19) && (y==25) && (n==3) && (s==0) && (u==1) && (((atoi(shortcodewert) > 5) && (atoi(shortcodewert) < 12)) || ((atoi(shortcodewert) > 12) && (atoi(shortcodewert) < 22)) || (atoi(shortcodewert) == 26) || ((atoi(shortcodewert) > 27) && (atoi(shortcodewert) < 30)) || ((atoi(shortcodewert) > 30) && (atoi(shortcodewert) < 34)))) scf();
  /* 50 T/Z MD */
  if((x==19) && (y==25) && (n==3) && (s==0) && (u==2) && (atoi(shortcodewert) > 33) && (atoi(shortcodewert) < 40)) scf();
  /* 100 T/Z WD */
  if((x==19) && (y==25) && (n==4) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 200 T/Z WD */
  if((x==19) && (y==25) && (n==5) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  /* 200 T/Z MD */
  if((x==19) && (y==25) && (n==5) && (s==0) && (u==2) && (atoi(shortcodewert) > 1) && (atoi(shortcodewert) < 4)) scf();
  /* 500 T/Z WD */
  if((x==19) && (y==25) && (n==6) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();

  // 5 U/M WD
  if((x==20) && (y==12) && (n==0) && (s==0) && (u==0) && (atoi(shortcodewert) < 5)) scf();
  // 5 U/M JCT
  if((x==20) && (y==12) && (n==0) && (s==0) && (u==1) && (atoi(shortcodewert) > 4) && (atoi(shortcodewert) < 9)) scf();
  // 10 U/M WD
  if((x==20) && (y==12) && (n==1) && (s==0) && (u==0) && (atoi(shortcodewert) == 1)) scf();
  // 10 U/M JCT
  if((x==20) && (y==12) && (n==1) && (s==0) && (u==1) && (atoi(shortcodewert) > 2) && (atoi(shortcodewert) < 9)) scf();
  // 20 U/M WD
  if((x==20) && (y==12) && (n==2) && (s==0) && (u==0) && (atoi(shortcodewert) < 7)) scf();
  // 20 U/M JCT
  if((x==20) && (y==12) && (n==2) && (s==0) && (u==1) && (atoi(shortcodewert) > 7) && (atoi(shortcodewert) < 20)) scf();
  // 20 U/M MD
  if((x==20) && (y==12) && (n==2) && (s==0) && (u==2) && (atoi(shortcodewert) > 20) && (atoi(shortcodewert) < 26)) scf();

  // 5 U/U MD Europa
  if((x==20) && (y==20) && (n==0) && (s==1) && (u==2) && (atoi(shortcodewert) > 2) && (atoi(shortcodewert) < 9)) scf();
  // 5 U/U CL Europa
  if((x==20) && (y==20) && (n==0) && (s==1) && (u==3) && ((atoi(shortcodewert) == 9) || ((atoi(shortcodewert) > 10) && (atoi(shortcodewert) < 13)))) scf();
  // 10 U/U MD Europa
  if((x==20) && (y==20) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) < 14)) scf();
  // 20 U/U Europa MD
  if((x==20) && (y==20) && (n==2) && (s==1) && (u==2) && ((atoi(shortcodewert) < 36))) scf();
  // 20 U/U Europa CL
  if((x==20) && (y==20) && (n==2) && (s==1) && (u==3) && (((atoi(shortcodewert) > 36) && (atoi(shortcodewert) < 48)) || (atoi(shortcodewert) == 51))) scf();
  // 50 U/U Europa MD
  if((x==20) && (y==20) && (n==3) && (s==1) && (u==2) && (atoi(shortcodewert) < 24)) scf();
  // 50 U/U Europa CL
  if((x==20) && (y==20) && (n==3) && (s==1) && (u==3) && (((atoi(shortcodewert) > 23) && (atoi(shortcodewert) < 46)) || ((atoi(shortcodewert) > 47) && (atoi(shortcodewert) < 51)))) scf();
  // 100 U/U Europa MD
  if((x==20) && (y==20) && (n==4) && (s==1) && (u==2) && (atoi(shortcodewert) < 6)) scf();
  // 200 U/U Europa MD
  if((x==20) && (y==20) && (n==5) && (s==1) && (u==2) && (atoi(shortcodewert) < 6)) scf();

  // 5 V/V MD Europa
  if((x==21) && (y==21) && (n==0) && (s==1) && (u==2) && (atoi(shortcodewert) < 14)) scf();
  // 5 V/V CL Europa
  if((x==21) && (y==21) && (n==0) && (s==1) && (u==3) && ((atoi(shortcodewert) > 13) && (atoi(shortcodewert) < 17))) scf();
  // 10 V011/V MD Europa can be MD or CL, there is an extra check for this
  // 10 V/V MD Europa
  if((x==21) && (y==21) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) < 11)) scf();
  // 10 V/V CL Europa
  if((x==21) && (y==21) && (n==1) && (s==1) && (u==3) && (atoi(shortcodewert) == 12)) scf();
  // 20 V/V Europa MD
  if((x==21) && (y==21) && (n==2) && (s==1) && (u==2) && ((atoi(shortcodewert) < 7))) scf();
  // 50 V018/V Europa can be MD or CL, there is an extra check for this
  // 50 V/V Europa MD
  if((x==21) && (y==21) && (n==3) && (s==1) && (u==2) && (atoi(shortcodewert) < 18)) scf();
  // 50 V/V Europa CL
  if((x==21) && (y==21) && (n==3) && (s==1) && (u==3) && ((atoi(shortcodewert) > 18) && (atoi(shortcodewert) < 35))) scf();
  // 100 V/V Europa MD
  if((x==21) && (y==21) && (n==4) && (s==1) && (u==2) && (atoi(shortcodewert) < 5)) scf();

  // 5 W/W Europa MD
  if((x==22) && (y==22) && (n==0) && (s==1) && (u==2) && (atoi(shortcodewert) < 3)) scf();
  // 10 W/W Europa MD
  if((x==22) && (y==22) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) < 3)) scf();
  // 10 W/W Europa CL
  if((x==22) && (y==22) && (n==1) && (s==1) && (u==3) && ((atoi(shortcodewert) > 2) && (atoi(shortcodewert) < 12))) scf();
  // 20 W/W Europa MD
  if((x==22) && (y==22) && (n==2) && (s==1) && (u==2) && (atoi(shortcodewert) < 3)) scf();
  // 50 W/W Europa MD
  if((x==22) && (y==22) && (n==3) && (s==1) && (u==2) && (atoi(shortcodewert) < 15)) scf();
  // 50 W/W Europa CL
  if((x==22) && (y==22) && (n==3) && (s==1) && (u==3) && ((atoi(shortcodewert) > 14) && (atoi(shortcodewert) < 17))) scf();
  // 100 W/W Europa CL
  if((x==22) && (y==22) && (n==4) && (s==1) && (u==3) && (atoi(shortcodewert) < 5)) scf();

  // 10 X/X MD Europa
  if((x==23) && (y==23) && (n==1) && (s==1) && (u==2) && (atoi(shortcodewert) < 4)) scf();
  // 20 X/X Europa MD
  if((x==23) && (y==23) && (n==2) && (s==1) && (u==2) && (atoi(shortcodewert) < 4)) scf();

  // 5 Y/Y Europa MD
  if((x==24) && (y==24) && (n==0) && (s==1) && (u==2) && (atoi(shortcodewert) < 8)) scf();
  // 10 Y/Y Europa MD
  if((x==24) && (y==24) && (n==1) && (s==1) && (u==2) && ((atoi(shortcodewert) < 10))) scf();
  // 10 Y/Y Europa CL
  if((x==24) && (y==24) && (n==1) && (s==1) && (u==3) && ((atoi(shortcodewert) > 9) && (atoi(shortcodewert) < 14))) scf();
  // 50 Y003/Y Europa can be MD or CL, there is an extra check for this
  // 50 Y/Y Europa MD
  if((x==24) && (y==24) && (n==3) && (s==1) && (u==2) && ((atoi(shortcodewert) < 3))) scf();
  // 50 Y/Y Europa CL
  if((x==24) && (y==24) && (n==3) && (s==1) && (u==3) && ((atoi(shortcodewert) == 4))) scf();

  // 5 Z/Z Europa JCT
  if((x==25) && (y==25) && (n==0) && (s==1) && (u==1) && (atoi(shortcodewert) == 2)) scf();
  // 5 Z/Z Europa MD
  if((x==25) && (y==25) && (n==0) && (s==1) && (u==2) && (((atoi(shortcodewert) > 2) && (atoi(shortcodewert) < 7)) || (atoi(shortcodewert) == 9) || (atoi(shortcodewert) == 20) || (atoi(shortcodewert) == 21))) scf();
  // 20 Z/Z Europa MD
  if((x==25) && (y==25) && (n==2) && (s==1) && (u==2) && ((atoi(shortcodewert) < 3) || (atoi(shortcodewert) == 20))) scf();
  // 50 Z/Z Europa MD
  if((x==25) && (y==25) && (n==3) && (s==1) && (u==2) && ((atoi(shortcodewert) < 6) || (atoi(shortcodewert) == 7) || ((atoi(shortcodewert) > 19) && (atoi(shortcodewert) < 23)))) scf();
 }
